package com.jpsoft.picc.modules.base.entity;

import java.io.Serializable;
import java.util.Date;
import java.text.SimpleDateFormat;
import java.math.BigDecimal;
import java.util.List;

import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.annotations.ApiModel;

/**
  描述:base_insurance_definition的实体类
 */
@Data
@ApiModel(value = "base_insurance_definition的实体类")
public class InsuranceDefinition {
    @ApiModelProperty(value = "编号")
	private String id;
    @ApiModelProperty(value = "险种")
	private String name;
    @ApiModelProperty(value = "投保声明")
	private String insuranceDescription;
    @ApiModelProperty(value = "雇主责任险条款")
	private String clause;
    @ApiModelProperty(value = "状态")
	private String status;
    @ApiModelProperty(value = "是否删除")
	private Boolean delFlag;
    @ApiModelProperty(value = "创建人")
	private String createBy;
	@DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
    @ApiModelProperty(value = "创建时间")
	private Date createTime;
    @ApiModelProperty(value = "修改人")
	private String updateBy;
	@DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
    @ApiModelProperty(value = "修改时间")
	private Date updateTime;
	@ApiModelProperty(value = "下月保单生效前提前多少天通知")
	private String cutOffTime;
	@ApiModelProperty(value = "下月保单生效前提前多少天自动提交")
	private Integer advanceSubmitDays;
    private List<InsuranceDefinitionLimit> limits;
	@ApiModelProperty(value = "理赔须知")
	private String notice;
	@ApiModelProperty(value = "致家长的一封信")
	private String letter;
	@ApiModelProperty(value = "特别声明")
	private String specialStatement;
	@ApiModelProperty(value = "责任免除说明")
	private String exemptionInstructions;
	@ApiModelProperty(value = "保险责任文本")
	private String responsibility;
	@ApiModelProperty(value = "附加险保险责任文本")
	private String responsibilityAttach;
	@ApiModelProperty(value = "是否拥有附加险")
	private Boolean haveAttach;
}