package com.jpsoft.picc.modules.base.entity;

import java.io.Serializable;
import java.util.Date;
import java.text.SimpleDateFormat;
import java.math.BigDecimal;

import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.annotations.ApiModel;

/**
 * 描述:base_insurance_definition_limit的实体类
 */
@Data
@ApiModel(value = "base_insurance_definition_limit的实体类")
public class InsuranceDefinitionLimit {
    @ApiModelProperty(value = "编号")
    private String id;
    @ApiModelProperty(value = "险种信息ID")
    private String definitionId;
    @ApiModelProperty(value = "险种信息")
    private InsuranceDefinition definition;
    @ApiModelProperty(value = "限额名称")
    private String name;
    @ApiModelProperty(value = "责任限额/免赔额")
    private String limit;
    @ApiModelProperty(value = "计算单位(次/元/人/万)")
    private String unit;
    @ApiModelProperty(value = "状态")
    private String status;
    @ApiModelProperty(value = "是否删除")
    private Boolean delFlag;
    @ApiModelProperty(value = "创建人")
    private String createBy;
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
    @ApiModelProperty(value = "创建时间")
    private Date createTime;
    @ApiModelProperty(value = "修改人")
    private String updateBy;
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
    @ApiModelProperty(value = "修改时间")
    private Date updateTime;
    @ApiModelProperty(value = "序号")
    private Integer sortNo;

    @ApiModelProperty(value = "累计/每次责任限额")
    private String singleLimit ;
    @ApiModelProperty(value = "适用条款")
    private String terms ;
    @ApiModelProperty(value = "免赔额")
    private String deductible ;
    @ApiModelProperty(value = "是否附加险")
    private Boolean isAttach ;

}