package com.jpsoft.picc.modules.business.dao;

import cn.hutool.core.date.DateTime;
import com.jpsoft.picc.modules.business.entity.InsurancePolicy;
import com.jpsoft.picc.modules.common.dto.Sort;
import org.springframework.stereotype.Repository;

import java.util.Date;
import java.util.List;
import java.util.Map;

@Repository
public interface InsurancePolicyDAO {
    int insert(InsurancePolicy entity);

    int update(InsurancePolicy entity);

    int exist(String id);

    InsurancePolicy get(String id);

    int delete(String id);

    List<InsurancePolicy> list();

    List<InsurancePolicy> search(Map<String, Object> searchParams, List<Sort> sortList);

    long countByApplicationIdAndEffectiveDate(String applicationId, String effectiveDate);

    List<InsurancePolicy> nextMonthPageList(Map<String, Object> searchParams, List<Sort> sortList);

    List<InsurancePolicy> findNextMonthPolicy(String companyId, String definitionId,Date startTime, Date endTime, String[] status);

    List<InsurancePolicy> toBeAdjustedPolicy(String status);

    List<InsurancePolicy> mySearch(Map<String, Object> searchParams, List<Sort> sortList);

    List<InsurancePolicy> hisSearch(Map<String, Object> searchParams, List<Sort> sortList);
}