package com.jpsoft.picc.modules.business.service.impl;

import com.github.pagehelper.Page;
import com.github.pagehelper.PageHelper;
import com.jpsoft.picc.modules.business.dao.InsuranceApplicationDAO;
import com.jpsoft.picc.modules.business.entity.InsuranceApplication;
import com.jpsoft.picc.modules.business.service.InsuranceApplicationService;
import com.jpsoft.picc.modules.common.dto.Sort;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import java.text.DecimalFormat;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;
import java.util.Map;

@Transactional
@Component(value = "insuranceApplicationService")
public class InsuranceApplicationServiceImpl implements InsuranceApplicationService {
    @Resource(name = "insuranceApplicationDAO")
    private InsuranceApplicationDAO insuranceApplicationDAO;

    @Override
    public InsuranceApplication get(String id) {
        // TODO Auto-generated method stub
        return insuranceApplicationDAO.get(id);
    }

    @Override
    public int insert(InsuranceApplication model) {
        // TODO Auto-generated method stub
        //model.setId(UUID.randomUUID().toString());

        return insuranceApplicationDAO.insert(model);
    }

    @Override
    public int update(InsuranceApplication model) {
        // TODO Auto-generated method stub
        return insuranceApplicationDAO.update(model);
    }

    @Override
    public int delete(String id) {
        // TODO Auto-generated method stub
        return insuranceApplicationDAO.delete(id);
    }

    @Override
    public boolean exist(String id) {
        // TODO Auto-generated method stub
        int count = insuranceApplicationDAO.exist(id);

        return count > 0 ? true : false;
    }

    @Override
    public List<InsuranceApplication> list() {
        // TODO Auto-generated method stub
        return insuranceApplicationDAO.list();
    }

    @Override
    public List<InsuranceApplication> findByCompanyId(String companyId,String status){
        return insuranceApplicationDAO.findByCompanyId(companyId,status);
    }

    @Override
    public List<InsuranceApplication> findByCompanyIdAndCreatTime(String companyId,String status,String startTime,String endTime){
        return insuranceApplicationDAO.findByCompanyIdAndCreatTime(companyId,status,startTime,endTime);
    }

    @Override
    public Page<InsuranceApplication> pageSearch(Map<String, Object> searchParams, int pageNumber, int pageSize, List<Sort> sortList) {
        Page<InsuranceApplication> page = PageHelper.startPage(pageNumber, pageSize).doSelectPage(() -> {
            insuranceApplicationDAO.search(searchParams, sortList);
        });

        return page;
    }

    @Override
    public List<InsuranceApplication> findByDuration(String companyId, String definitionId, Date startTime, Date endTime,String[] status) {
        return insuranceApplicationDAO.findByDuration(companyId,definitionId,startTime,endTime,status);
    }

    @Override
    public List<InsuranceApplication> findByCombinePolicyId(String combinePolicyId) {
        return insuranceApplicationDAO.findByCombinePolicyId(combinePolicyId);
    }

    @Override
    public String generatePolicyNo(Date createTime,int num) {
        //（yyMMddHHmm）+(XXX=今日第几单)-(XX=第几个月)
        long count = countByCreateTime(createTime)+1;

        SimpleDateFormat sdf = new SimpleDateFormat("yyMMddHHmm");
        DecimalFormat df1 = new DecimalFormat("000");
        DecimalFormat df2 = new DecimalFormat("00");

        String policyNo = sdf.format(createTime) + df1.format(count) + "-" + df2.format(num);

        return policyNo;
    }

    @Override
    public long countByCreateTime(Date createTime) {
        return insuranceApplicationDAO.countByCreateTime(createTime);
    }
}