package com.jpsoft.weixin.callback;

import cn.hutool.core.collection.CollUtil;
import com.jpsoft.weixin.entity.ReplyMessage;
import com.jpsoft.weixin.service.ReplyMessageService;
import com.jpsoft.weixin.utils.VelocityHelper;
import lombok.extern.slf4j.Slf4j;
import java.net.URLEncoder;
import java.util.HashMap;
import java.util.Map;

@Slf4j
public class PromotionCallback extends EventCallback {
    private ReplyMessageService replyMessageService;

    public PromotionCallback(String code,String callbackUrl){
        super(code,callbackUrl);
    }

    public void setReplyMessageService(ReplyMessageService replyMessageService) {
        this.replyMessageService = replyMessageService;
    }

    @Override
    public boolean process(String wechatId,String openId, String eventKey) {
        boolean result = false;

        try {
            String[] arr = eventKey.split(",");

            String promoter = arr[1];

            StringBuilder urlBuilder = new StringBuilder();

            urlBuilder.append(this.getCallbackUrl());
            urlBuilder.append("?openId=" + openId);
            urlBuilder.append("&promoter=" + URLEncoder.encode(promoter, "UTF-8"));

            ReplyMessage replyMessage = replyMessageService.findByEvent(wechatId,"promotion");

            if(replyMessage!=null) {
                Map<String, Object> vars = new HashMap<>();
                vars.put("callbackUrl", urlBuilder.toString());

                setMessage(VelocityHelper.format(replyMessage.getMessage(), vars));
            }
            else{
                setMessage("模板未配置!");
            }

            result = true;
        }
        catch (Exception ex){
            result =false;
            log.error(ex.getMessage(),ex);
        }

        return result;
    }
}
